#include "1886VE5.h"

unsigned char PWMCnt, cmd, a;
const int b = 0x10;
uns32 c;
/****************************************************/
#include "int17xxx.h"
#pragma origin 0x8
interrupt iServer(void)
{
    multi_interrupt_entry_and_save

 PERIPHERAL_service:
 TMR0_service:
    // save on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
    /* process Timer 0 interrupt */
    // T0IF is automatically cleared when the CPU vectors to 0x10
    // restore on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
     T1IF = 0;
     PW1DCH = PW1DCH + 0x10;
     if (PW1DCH == 0)
        if (--PWMCnt == 0)
           TCON2 = 0; // stop
 T0CKI_service:
 INT_service:
    interrupt_exit_and_restore
}

//#include <math32.h>
/****************************************************/
void Beep()
{
     PW1DCH = 0;
     PWMCnt = 0;
     TCON2 = 0x11; // start interrupt
}

/****************************************************/
void main()
{/*      :
; PA0 (.) INH_MK
; PA1 (.)      32..8
; PA2 (.)     USART
; PA3 ()     USART
; PA4  
; PA5 () NSLP_LIN

; PC0 ( )  
; PC1   
 
; PC2-7 (.)  0-5

; PD0,1 (.)  6,7
; PD2 (.)  1
; PD3 (.)  SW3
; PD4-7 (.) Led0-3

; PE0-3 (.) Led4-7
*/
  GLINTD = 1;
  PORTA = 0;
  DDRA = 0b000111;
  
  PORTD = 0;
  DDRD = 0b00001011;
  PORTE = 0; // Led4-7 off 
  DDRE = 0; // output
  
  DDRC = 0b11111111; // all input (after reset)
  ADCON1 = 0b01101100; // set analog input, Fc/32
  ADCON0 = 0b00000000; // AD0
  ADON = 1; // ADC on
  
  T0STA = 0b00100100; // Timer0 1:4, 15Hz for 16MHz
  cmd = 0;
// init PWM
  PR1 = 0xFF; //Period
  PW1DCL = 0x00;
  PIR1 = 0x00;
  PIE1 = 0x10;
  INTSTA = 0x08;
  TCON1 = 0x00;
  TCON2 = 0x00;
  
//  TMR0H = 0xFF; // for LF resonator
  
  GLINTD = 0; // interrupt enable
  Beep();
  GO_DONE = 1; // Start adc
  while(1){ // main loop
    if (T0IF) // Timer0 Interrupt Flag
    {
      T0IF = 0; // clear Timer0 Interrupt flag
//      TMR0H = 0xFF; // for LF resonator
      cmd++;
        PORTD = (cmd << 4);// & 0xF0;
        PORTE = (cmd >> 4);// & 0x0F;
      if (!GO_DONE)
      {  
        //TXREG1 = ADRESH | ((PORTD & 0x08) << 4); // send Button and high bits of ADC
        //while (!TX1IF){}
        a = ADRESH;
        a = ADRESL;
        GO_DONE = 1; // Start ADC
      }
    }
  }
}
