;*******************************************************************************
            include <1886VE6M.INC>
;*******************************************************************************
PCLAT_1     EQU         001EH       ;    PCLATH  
BSR_1       EQU         001FH       ;    BSR  
ALUST_1     EQU         0020H       ;    ALUSTA  
WREG_1      EQU         0021H       ;    WREG  
COUNT       EQU         0029H       ;  
DATAREG     EQU         002CH       ;     
RLREG       EQU         0022H       ;     
LREG        EQU         0023H
RREG        EQU         0024H
LON         EQU         0025H
LOFF        EQU         0026H
RON         EQU         0027H
ROFF        EQU         0028H
MIG         EQU         002AH       ;   
Capas       EQU         002BH       ;         
ACPCOUNT    EQU         002DH       ;     
ZNREG       EQU         002FH       ;       
CHANEL      EQU         0030H       ;  
UREG        EQU         0031H       ;     
DREG        EQU         0032H
UON         EQU         0033H
UOFF        EQU         0034H
DON         EQU         0035H
DOFF        EQU         0036H
CHREG       EQU         0037H       ;       
ACP1H       EQU         0038H       ;   , ,      RS_232
ACP1M       EQU         0039H
ACP1L       EQU         003AH
ACP2H       EQU         003BH
ACP2M       EQU         003CH
ACP2L       EQU         003DH
ACP3H       EQU         003EH
ACP3M       EQU         003FH
ACP3L       EQU         0040H
ACP4H       EQU         0041H
ACP4M       EQU         0042H
ACP4L       EQU         0043H
PWM1H       EQU         0044H
PWM1M       EQU         0045H
PWM1L       EQU         0046H
PWM2H       EQU         0047H
PWM2M       EQU         0048H
PWM2L       EQU         0049H
PWM1HB      EQU         004AH
PWM1MB      EQU         004BH
PWM1LB      EQU         004CH
PWM2HB      EQU         004DH
PWM2MB      EQU         004EH
PWM2LB      EQU         004FH
D1H         EQU         0050H
D1M         EQU         0051H
D1L         EQU         0052H
D2H         EQU         0053H
D2M         EQU         0054H
D2L         EQU         0055H
DATAH       EQU         0056H
DATAL       EQU         0057H
DATARXH     EQU         001AH
DATARXL     EQU         001BH
;*******************************************************************************
            ORG         00H
;*******************************************************************************
Start:      BCF         GLINTD      ;     

            BSF         T0IE        ;    0
            BSF         T0CS        ;     
            
            MOVLB       03H         ;    3
            MOVLW       31H
            MOVWF       TCON2       ;  
            CLRF        TCON1,F
                        
            MOVLB       04H         ;    4
            MOVLW       6CH
            MOVWF       DAC_CONT    ;  
            MOVLW       03H
            MOVWF       COMPARE     ;  
            
            MOVLB       06H
            MOVLW       64H
            MOVWF       ADCON1      ;  
            
            GOTO        ClrReg
;*******************************************************************************
            ORG         10H
;*******************************************************************************
            MOVPF       ALUSTA,ALUST_1          ;  
            MOVPF       WREG,WREG_1
            MOVPF       BSR,BSR_1
            MOVPF       PCLATH,PCLAT_1
            
            GOTO        ACP                     ;    

EndT0:      INCF        COUNT,F                 ;     
            MOVLW       04H
            CPFSLT      COUNT
            CLRF        COUNT,F

            BCF         T0IF                    ;    
            MOVLW       0C0H                    ;    0
            MOVWF       TMR0H 

            MOVFP       BSR_1,BSR               ;  
            MOVFP       PCLAT_1,PCLATH 
            MOVFP       ALUST_1,ALUSTA                                     
            MOVFP       WREG_1,WREG
            
            RETFIE
;*******************************************************************************
;                                                                                
;*******************************************************************************            
ACP:        MOVLB       06H                     ;                                                
            INCF        ACPCOUNT,F
            MOVLW       017H
            CPFSEQ      ACPCOUNT
            GOTO        Ind                     ;       
            CLRF        ACPCOUNT,F
            MOVFP       COUNT,WREG              ;         
            GOTO        ACPTABL  
;*******************************************************************************
ACP1:       MOVLW       21H                     ;                                                                    
            MOVWF       ADCON0
            
            MOVLW       032H                    ;    
            MOVWF       Capas
Chold:      DECFSZ      Capas,1
            GOTO        Chold

            BSF         ADCON0,2                ;  

WD:         CLRWDT                                                                              
            BTFSC       ADCON0,2                ;                                                   
            GOTO        WD
            
            MOVPF       ADRESL,ACP1L            ;       3 
            MOVLW       0FH
            ANDWF       ACP1L,F
            MOVPF       ADRESL,ACP1M
            SWAPF       ACP1M,F
            ANDWF       ACP1M,F
            MOVPF       ADRESH,ACP1H
            
            MOVPF       ADRESH,DATAH            ;      RS_232           
            MOVPF       ADRESL,DATAL
            
            RLNCF       DATAH,F
            BSF         DATAH,0
            BTFSS       DATAL,7
            BCF         DATAH,0
            
            GOTO        RS_232            
;*******************************************************************************            
ACP2:       MOVLW       31H                     ;  ACP1                                          
            MOVWF       ADCON0
            
            MOVLW       032H
            MOVWF       Capas
Chold2:     DECFSZ      Capas,1
            GOTO        Chold2

            BSF         ADCON0,2

WD2:        CLRWDT                                                                              
            BTFSC       ADCON0,2
            GOTO        WD2
            
            MOVPF       ADRESL,ACP2L
            MOVLW       0FH
            ANDWF       ACP2L,F
            MOVPF       ADRESL,ACP2M
            SWAPF       ACP2M,F
            ANDWF       ACP2M,F
            MOVPF       ADRESH,ACP2H
            
            MOVPF       ADRESH,DATAH            
            MOVPF       ADRESL,DATAL
            
            RLNCF       DATAH,F
            BSF         DATAH,0
            BTFSS       DATAL,7
            BCF         DATAH,0
            
            MOVLW       20H
            ADDWF       DATAH,F

            GOTO        RS_232            
;*******************************************************************************            
ACP3:       MOVLW       41H                     ;  ACP1
            MOVWF       ADCON0
            
            MOVLW       032H
            MOVWF       Capas
Chold3:     DECFSZ      Capas,1
            GOTO        Chold3

            BSF         ADCON0,2

WD3:        CLRWDT                                                                              
            BTFSC       ADCON0,2
            GOTO        WD3
            
            MOVPF       ADRESL,ACP3L
            MOVLW       0FH
            ANDWF       ACP3L,F
            MOVPF       ADRESL,ACP3M
            SWAPF       ACP3M,F
            ANDWF       ACP3M,F
            MOVPF       ADRESH,ACP3H
            
            MOVPF       ADRESH,DATAH            
            MOVPF       ADRESL,DATAL
            
            RLNCF       DATAH,F
            BSF         DATAH,0
            BTFSS       DATAL,7
            BCF         DATAH,0
            
            MOVLW       40H
            ADDWF       DATAH,F

            GOTO        RS_232          
;*******************************************************************************
ACP4:       MOVLW       51H                     ;  ACP1
            MOVWF       ADCON0
            
            MOVLW       032H
            MOVWF       Capas
Chold4:     DECFSZ      Capas,1
            GOTO        Chold4

            BSF         ADCON0,2

WD4:        CLRWDT                                                                              
            BTFSC       ADCON0,2
            GOTO        WD4
            
            MOVPF       ADRESL,ACP4L
            MOVLW       0FH
            ANDWF       ACP4L,F
            MOVPF       ADRESL,ACP4M
            SWAPF       ACP4M,F
            ANDWF       ACP4M,F
            MOVPF       ADRESH,ACP4H
             
            MOVPF       ADRESH,DATAH
            MOVPF       ADRESL,DATAL
            
            RLNCF       DATAH,F
            BSF         DATAH,0
            BTFSS       DATAL,7
            BCF         DATAH,0
            
            MOVLW       60H
            ADDWF       DATAH,F

            GOTO        RS_232                      
;*******************************************************************************
ACPTABL:    ADDWF       PCL,F
            GOTO        ACP1
            GOTO        ACP2
            GOTO        ACP3
            GOTO        ACP4 
;*******************************************************************************
;                           
;*******************************************************************************
Button:     MOVLB       01H                                                       
            MOVFP       COUNT,WREG
            GOTO        BTABL
;*******************************************************************************            
Left:       MOVLW       04H
            BTFSC       PORTC,7
            GOTO        LeftOFF           
                                    
LeftON:     CLRF        LOFF,F
            INCF        LON,F
            CPFSLT      LON
            BSF         LREG,1
            CPFSLT      LON
            CLRF        LON,F
            GOTO        TotalL
            
LeftOFF:    CLRF        LON,F
            INCF        LOFF,F
            CPFSLT      LOFF
            RRNCF       LREG,F
            CPFSLT      LOFF
            CLRF        LOFF,F
            
TotalL:     BTFSS       LREG,0
            GOTO        EndT0
            TSTFSZ      RLREG
            DECF        RLREG,F
            CLRF        LREG,F
            GOTO        EndT0
;*******************************************************************************                         
Right:      MOVLW       04H
            BTFSC       PORTC,7
            GOTO        RightOFF 

RightON:    CLRF        ROFF,F
            INCF        RON,F
            CPFSLT      RON
            BSF         RREG,1
            CPFSLT      RON
            CLRF        RON,F
            GOTO        TotalR
            
RightOFF:   CLRF        RON,F
            INCF        ROFF,F
            CPFSLT      ROFF
            RRNCF       RREG,F
            CPFSLT      ROFF
            CLRF        ROFF,F

TotalR:     BTFSS       RREG,0
            GOTO        EndT0
            MOVLW       03H
            CPFSEQ      RLREG
            INCF        RLREG,F
            CLRF        RREG,F
            GOTO        EndT0
;*******************************************************************************  
Up:         MOVLW       04H
            BTFSC       PORTC,7
            GOTO        UpOFF           
                                    
UpON:       CLRF        UOFF,F
            INCF        UON,F
            CPFSLT      UON
            BSF         UREG,1
            CPFSLT      UON
            CLRF        UON,F
            GOTO        TotalU
            
UpOFF:      CLRF        UON,F
            INCF        UOFF,F
            CPFSLT      UOFF
            RRNCF       UREG,F
            CPFSLT      UOFF
            CLRF        UOFF,F
            
TotalU:     BTFSS       UREG,0
            GOTO        EndT0
            MOVFP       RLREG,WREG
            GOTO        UpR
TotalUOUT:  CLRF        UREG,F
            GOTO        EndT0
;*******************************************************************************
Down:       MOVLW       04H
            BTFSC       PORTC,7
            GOTO        DownOFF

DownON:     CLRF        DOFF,F
            INCF        DON,F
            CPFSLT      DON
            BSF         DREG,1
            CPFSLT      DON
            CLRF        DON,F
            GOTO        TotalD
            
DownOFF:    CLRF        DON,F
            INCF        DOFF,F
            CPFSLT      DOFF
            RRNCF       DREG,F
            CPFSLT      DOFF
            CLRF        DOFF,F
            
TotalD:     BTFSS       DREG,0
            GOTO        EndT0
            MOVFP       RLREG,WREG
            GOTO        DownR
TotalDOUT:  CLRF        DREG,F
            GOTO        EndT0  
;*******************************************************************************
BTABL:      ADDWF       PCL,F
            GOTO        Right
            GOTO        Down
            GOTO        Up
            GOTO        Left
;*******************************************************************************            
DownR:      ADDWF       PCL,F
            GOTO        DecCH
            GOTO        Dec3
            GOTO        Dec2
            GOTO        Dec1
            
UpR:        ADDWF       PCL,F
            GOTO        UpCH
            GOTO        Up3
            GOTO        Up2
            GOTO        Up1 
;*******************************************************************************            
            ORG         100H                                                                                                                        
;*******************************************************************************
;           
;*******************************************************************************
Ind:        MOVLB       01H
                                    
            MOVFP       COUNT,WREG            ;    
            MOVWF       ZNREG
            MOVFP       CHANEL,WREG            
            MOVWF       CHREG
            DECF        CHREG,F
            RLNCF       ZNREG,F
            RLNCF       CHREG,F
            RLNCF       CHREG,F
            RLNCF       CHREG,W
            ADDWF       ZNREG,W
            GOTO        DATATABL
            
Znak:       CALL        ZNGen
            MOVWF       DATAREG            
                                   
            MOVFP       RLREG,WREG             ;  
            CPFSEQ      COUNT
            GOTO        Peredacha             

            BTFSS       MIG,4
            BSF         DATAREG,7
            INCF        MIG,F
                        
Peredacha:  BCF         DDRC,7                 ;     
            SETF        PORTD,F
            BSF         PORTC,7
            BTFSS       DATAREG,7
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6                                                                                                                           

            BSF         PORTC,7
            BTFSS       DATAREG,6
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     

            BSF         PORTC,7
            BTFSS       DATAREG,5
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     

            BSF         PORTC,7
            BTFSS       DATAREG,4
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     

            BSF         PORTC,7
            BTFSS       DATAREG,3
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     
            
            BSF         PORTC,7
            BTFSS       DATAREG,2
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     
            
            BSF         PORTC,7
            BTFSS       DATAREG,1
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     
            
            BSF         PORTC,7
            BTFSS       DATAREG,0
            BCF         PORTC,7
            BSF         PORTC,6
            BCF         PORTC,6     

            BSF         DDRC,7

            MOVFP       COUNT,WREG      ;                                                                                                                     
            CALL        TABL
            MOVWF       PORTD
            GOTO        PWMLoad         ;       
;*******************************************************************************
            ORG         150H
;*******************************************************************************                                                                          
TABL:       ADDWF       PCL,F
            RETLW       0FEH          
            RETLW       0FDH                          
            RETLW       0EFH                        
            RETLW       0DFH
;*******************************************************************************            
ZNGen:      ADDWF       PCL,F
            RETLW       03FH                         ; "0"
            RETLW       006H                         ; "1"
            RETLW       05BH                         ; "2"
            RETLW       04FH                         ; "3"
            RETLW       066H                         ; "4"
            RETLW       06DH                         ; "5"
            RETLW       07DH                         ; "6"
            RETLW       007H                         ; "7"
            RETLW       07FH                         ; "8"
            RETLW       06FH                         ; "9"
            RETLW       077H                         ; "A"
            RETLW       07CH                         ; "b"
            RETLW       039H                         ; "C"
            RETLW       05EH                         ; "d"
            RETLW       079H                         ; "E"
            RETLW       071H                         ; "F" 
;*******************************************************************************
;               
;*******************************************************************************             
DATATABL:   ADDWF       PCL,F            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       ACP1H,WREG
            GOTO        Znak
            MOVFP       ACP1M,WREG
            GOTO        Znak
            MOVFP       ACP1L,WREG
            GOTO        Znak
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       ACP2H,WREG
            GOTO        Znak
            MOVFP       ACP2M,WREG
            GOTO        Znak
            MOVFP       ACP2L,WREG
            GOTO        Znak  
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       ACP3H,WREG
            GOTO        Znak
            MOVFP       ACP3M,WREG
            GOTO        Znak
            MOVFP       ACP3L,WREG
            GOTO        Znak  
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       ACP4H,WREG
            GOTO        Znak
            MOVFP       ACP4M,WREG
            GOTO        Znak
            MOVFP       ACP4L,WREG
            GOTO        Znak
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       PWM1H,WREG
            GOTO        Znak
            MOVFP       PWM1M,WREG
            GOTO        Znak
            MOVFP       PWM1L,WREG
            GOTO        Znak
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       PWM2H,WREG
            GOTO        Znak
            MOVFP       PWM2M,WREG
            GOTO        Znak
            MOVFP       PWM2L,WREG
            GOTO        Znak
            
            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       D1H,WREG
            GOTO        Znak
            MOVFP       D1M,WREG
            GOTO        Znak
            MOVFP       D1L,WREG
            GOTO        Znak

            MOVFP       CHANEL,WREG
            GOTO        Znak
            MOVFP       D2H,WREG
            GOTO        Znak
            MOVFP       D2M,WREG
            GOTO        Znak
            MOVFP       D2L,WREG
            GOTO        Znak
;*******************************************************************************                       
;              
;******************************************************************************* 
PWMLoad:    MOVFP       PWM1L,WREG       ;         
            MOVWF       PWM1LB           ;      
            MOVFP       PWM1M,WREG
            MOVWF       PWM1MB 
            MOVFP       PWM1H,WREG
            MOVWF       PWM1HB
            MOVFP       PWM2L,WREG
            MOVWF       PWM2LB
            MOVFP       PWM2M,WREG
            MOVWF       PWM2MB
            MOVFP       PWM2H,WREG
            MOVWF       PWM2HB            
                        
            SWAPF       PWM1LB,F          ;        
            RLCF        PWM1LB,F
            RLCF        PWM1MB,F
            RLCF        PWM1LB,F
            RLCF        PWM1MB,F
            MOVLW       0C0H
            ANDWF       PWM1LB,F
            RLNCF       PWM1MB,F            
            RLNCF       PWM1MB,F
            RRCF        PWM1HB,F
            RRCF        PWM1MB,F
            RRCF        PWM1HB,F
            RRCF        PWM1MB,F 
            MOVLW       03H
            ANDWF       PWM1HB,F
                                     
            SWAPF       PWM2LB,F
            RLCF        PWM2LB,F
            RLCF        PWM2MB,F
            RLCF        PWM2LB,F
            RLCF        PWM2MB,F
            MOVLW       0C0H
            ANDWF       PWM2LB,F
            RLNCF       PWM2MB,F            
            RLNCF       PWM2MB,F
            RRCF        PWM2HB,F
            RRCF        PWM2MB,F
            RRCF        PWM2HB,F
            RRCF        PWM2MB,F 
            MOVLW       03H
            ANDWF       PWM2HB,F
            
            MOVLB       05H              ;    5
            BCF         TMR1IF           ;                                                
            
TMR:        BTFSS       TMR1IF           ;   
            GOTO        TMR
            
            MOVLB       03H              ;    3
            
            MOVFP       PWM1LB,PW1DCL    ;        
            MOVFP       PWM2LB,PW2DCL                                                                                                                                  

            MOVFP       PWM1MB,PW1DCH
            MOVFP       PWM2MB,PW2DCH 

            MOVLB       04H

            MOVFP       PWM1HB,PW1DCHH
            MOVFP       PWM2HB,PW2DCHH
            
            GOTO        DACLoad          ;                                                                                                                                     
;*******************************************************************************
;              
;*******************************************************************************           
DACLoad:    MOVLB       04H              ;    4                                                  
            
            SWAPF       D1H,W            ;      
            ADDWF       D1M,W
            MOVWF       DAC1H
            SWAPF       D1L,W
            MOVWF       DAC1L

            SWAPF       D2H,W
            ADDWF       D2M,W
            MOVWF       DAC2H
            SWAPF       D2L,W
            MOVWF       DAC2L            
             
            GOTO        Button           ;    
;*******************************************************************************                       
            ORG         200H
;******************************************************************************* 
;                                                                                    
;*******************************************************************************             
DecCH:      MOVLW       01H
            CPFSEQ      CHANEL
            DECF        CHANEL,F
            GOTO        TotalDOUT
             
Dec3:       MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        DecPWM1H
            GOTO        DecPWM2H
            GOTO        DecDAC1H
            GOTO        DecDAC2H
            
Dec2:       MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        DecPWM1M
            GOTO        DecPWM2M
            GOTO        DecDAC1M
            GOTO        DecDAC2M
                        
Dec1:       MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT 
            GOTO        DecPWM1L
            GOTO        DecPWM2L
            GOTO        DecDAC1L
            GOTO        DecDAC2L
;*******************************************************************************             
UpCH:       MOVLW       08H
            CPFSEQ      CHANEL
            INCF        CHANEL,F
            GOTO        TotalUOUT  
             
Up3:        MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalUOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT 
            GOTO        UpPWM1H
            GOTO        UpPWM2H
            GOTO        UpDAC1H
            GOTO        UpDAC2H  
            
Up2:        MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalUOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        UpPWM1M
            GOTO        UpPWM2M
            GOTO        UpDAC1M
            GOTO        UpDAC2M   
            
Up1:        MOVFP       CHANEL,WREG
            ADDWF       PCL,F
            NOP
            GOTO        TotalUOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        TotalDOUT
            GOTO        UpPWM1L
            GOTO        UpPWM2L
            GOTO        UpDAC1L
            GOTO        UpDAC2L             
;*******************************************************************************
DecPWM1H:   TSTFSZ      PWM1H
            DECF        PWM1H,F
            GOTO        TotalDOUT
            
DecPWM1M:   TSTFSZ      PWM1M
            DECF        PWM1M,F
            GOTO        TotalDOUT 
            
DecPWM1L:   TSTFSZ      PWM1L
            DECF        PWM1L,F
            GOTO        TotalDOUT              
;*******************************************************************************
UpPWM1H:    MOVLW       0FH
            CPFSEQ      PWM1H
            INCF        PWM1H,F
            GOTO        TotalUOUT
            
UpPWM1M:    MOVLW       0FH
            CPFSEQ      PWM1M
            INCF        PWM1M,F
            GOTO        TotalUOUT 
            
UpPWM1L:    MOVLW       0FH
            CPFSEQ      PWM1L
            INCF        PWM1L,F
            GOTO        TotalUOUT 
;*******************************************************************************
DecPWM2H:   TSTFSZ      PWM2H
            DECF        PWM2H,F
            GOTO        TotalDOUT
            
DecPWM2M:   TSTFSZ      PWM2M
            DECF        PWM2M,F
            GOTO        TotalDOUT 
            
DecPWM2L:   TSTFSZ      PWM2L
            DECF        PWM2L,F
            GOTO        TotalDOUT              
;*******************************************************************************
UpPWM2H:    MOVLW       0FH
            CPFSEQ      PWM2H
            INCF        PWM2H,F
            GOTO        TotalUOUT
            
UpPWM2M:    MOVLW       0FH
            CPFSEQ      PWM2M
            INCF        PWM2M,F
            GOTO        TotalUOUT 
            
UpPWM2L:    MOVLW       0FH
            CPFSEQ      PWM2L
            INCF        PWM2L,F
            GOTO        TotalUOUT 
;*******************************************************************************
DecDAC1H:   TSTFSZ      D1H
            DECF        D1H,F
            GOTO        TotalDOUT
            
DecDAC1M:   TSTFSZ      D1M
            DECF        D1M,F
            GOTO        TotalDOUT 
            
DecDAC1L:   TSTFSZ      D1L
            DECF        D1L,F
            GOTO        TotalDOUT              
;*******************************************************************************
UpDAC1H:    MOVLW       0FH
            CPFSEQ      D1H
            INCF        D1H,F
            GOTO        TotalUOUT
            
UpDAC1M:    MOVLW       0FH
            CPFSEQ      D1M
            INCF        D1M,F
            GOTO        TotalUOUT 
            
UpDAC1L:    MOVLW       0FH
            CPFSEQ      D1L
            INCF        D1L,F
            GOTO        TotalUOUT 
;*******************************************************************************
DecDAC2H:   TSTFSZ      D2H
            DECF        D2H,F
            GOTO        TotalDOUT
            
DecDAC2M:   TSTFSZ      D2M
            DECF        D2M,F
            GOTO        TotalDOUT 
            
DecDAC2L:   TSTFSZ      D2L
            DECF        D2L,F
            GOTO        TotalDOUT              
;*******************************************************************************
UpDAC2H:    MOVLW       0FH
            CPFSEQ      D2H
            INCF        D2H,F
            GOTO        TotalUOUT
            
UpDAC2M:    MOVLW       0FH
            CPFSEQ      D2M
            INCF        D2M,F
            GOTO        TotalUOUT 
            
UpDAC2L:    MOVLW       0FH
            CPFSEQ      D2L
            INCF        D2L,F
            GOTO        TotalUOUT
;*******************************************************************************  
;                RS_232
;*******************************************************************************
RS_232:     MOVLB       07H             ;    7
            
            BSF         DATAH,7         ;        
            BCF         DATAL,7
            
            MOVFP       DATAH,TXREG2    ;     
            MOVFP       DATAL,TXREG2
            
            MOVLB       05H             ;    5
            BTFSS       RC2IF           ;       
            GOTO        Ind             ;      
            MOVLB       07H             ;    7
            
            MOVPF       RCREG2,DATARXH  ;     
            BTFSS       DATARXH,7       ;     
            GOTO        Ind             ;      
            
            MOVLB       05H             ;    5
            BTFSS       RC2IF           ;       
            GOTO        Ind             ;      
            MOVLB       07H             ;    7
            
            MOVPF       RCREG2,DATARXL  ;     
            BTFSC       DATARXL,7       ;     
            GOTO        Ind             ;      
            
            RLNCF       DATARXL,F       ;       
            RRCF        DATARXH,F
            RRCF        DATARXL,F
            
            SWAPF       DATARXH,W
            ANDLW       03H
            GOTO        RSTABL          ;           
;*******************************************************************************             
PWM1Load:   MOVPF       DATARXL,PWM1L   ;            
            MOVLW       0FH
            ANDWF       PWM1L,F
            MOVPF       DATARXL,PWM1M
            SWAPF       PWM1M,F
            ANDWF       PWM1M,F
            MOVPF       DATARXH,PWM1H
            ANDWF       PWM1H,F
            GOTO        Ind
;*******************************************************************************             
PWM2Load:   MOVPF       DATARXL,PWM2L
            MOVLW       0FH
            ANDWF       PWM2L,F
            MOVPF       DATARXL,PWM2M
            SWAPF       PWM2M,F
            ANDWF       PWM2M,F
            MOVPF       DATARXH,PWM2H
            ANDWF       PWM2H,F
            GOTO        Ind
;*******************************************************************************             
DAC1Load:   MOVPF       DATARXL,D1L
            MOVLW       0FH
            ANDWF       D1L,F
            MOVPF       DATARXL,D1M
            SWAPF       D1M,F
            ANDWF       D1M,F
            MOVPF       DATARXH,D1H
            ANDWF       D1H,F
            GOTO        Ind
;*******************************************************************************             
DAC2Load:   MOVPF       DATARXL,D2L
            MOVLW       0FH
            ANDWF       D2L,F
            MOVPF       DATARXL,D2M
            SWAPF       D2M,F
            ANDWF       D2M,F
            MOVPF       DATARXH,D2H
            ANDWF       D2H,F
            GOTO        Ind
;*******************************************************************************             
RSTABL:     ADDWF       PCL,F
            GOTO        PWM1Load
            GOTO        PWM2Load
            GOTO        DAC1Load
            GOTO        DAC2Load                                                                            
;*******************************************************************************  
;           ,  ,  
;*******************************************************************************
ClrReg:     MOVLB       07H         ;    0

            MOVLW       33H
            MOVWF       SPBRG2      ;    9600
            BSF         SPEN2       ;  USART
            BSF         CREN2       ;  
            BSF         TXEN2       ;              
            
            MOVLB       02H

            MOVLW       03H
            MOVWF       PR1H
            SETF        PR1L,F
            
            MOVLB       01H
            
            MOVLW       3FH
            MOVWF       DDRC
            MOVLW       0C0H
            MOVWF       DDRD
            CLRF        PORTC,F
            CLRF        PORTD,F
            CLRF        COUNT,F
            CLRF        CHANEL,F
            INCF        CHANEL,F
            CLRF        MIG,F
            CLRF        RLREG,F  
            CLRF        LREG,F
            CLRF        RREG,F
            CLRF        LON,F
            CLRF        LOFF,F
            CLRF        RON,F
            CLRF        ROFF,F                                                                  
            CLRF        UREG,F
            CLRF        DREG,F
            CLRF        UON,F
            CLRF        UOFF,F
            CLRF        DON,F
            CLRF        DOFF,F
            CLRF        ZNREG,F
            CLRF        CHREG,F
            CLRF        ACPCOUNT,F
            CLRF        ACP1H,F
            CLRF        ACP1M,F
            CLRF        ACP1L,F
            CLRF        ACP2H,F
            CLRF        ACP2M,F
            CLRF        ACP2L,F 
            CLRF        ACP3H,F
            CLRF        ACP3M,F
            CLRF        ACP3L,F 
            CLRF        ACP4H,F
            CLRF        ACP4M,F
            CLRF        ACP4L,F                         
            CLRF        PWM1H,F
            CLRF        PWM1M,F
            CLRF        PWM1L,F
            CLRF        PWM2H,F
            CLRF        PWM2M,F
            CLRF        PWM2L,F
            CLRF        PWM1HB,F
            CLRF        PWM1MB,F
            CLRF        PWM1LB,F
            CLRF        PWM2HB,F
            CLRF        PWM2MB,F
            CLRF        PWM2LB,F
            CLRF        D1L,F
            CLRF        D1M,F
            CLRF        D1H,F
            CLRF        D2L,F
            CLRF        D2M,F
            CLRF        D2H,F
            CLRF        DATAH,F
            CLRF        DATAL,F
            CLRF        DATARXH,F
            CLRF        DATARXL,F
                                    
Circle:     CLRWDT
            GOTO        Circle   
;*******************************************************************************                      
            END                                                                                                                          
