#include <1886ve3d.h>
#include "int17xxx.h"
unsigned char Temp;	//      TMR0
unsigned char DataInp;	//  ,   
unsigned char DataOut;	//   
unsigned char FLAG;    //  
bit FLAG1;   //      
bit FLAG7;   //  /  
//------------------------------------------------------------------------------
void PAUSE(unsigned char);

#pragma origin 0x8
interrupt iServer(void){
  multi_interrupt_entry_and_save
    // save on demand: TBLPTRH,TBLPTRL,FSR0,FSR1
 TMR0_service:
    T0IF = 0;
    DDRE = 0xF0;//PORTE 4-7 - 
    PORTE = 0x07;
    PAUSE(6);        
    Temp = PORTE & 0xF0; //   
    PORTE = 0x0b;
    PAUSE(6);
    Temp = Temp | (PORTE >> 4); // Temp     
    if(Temp != DataInp){
      FLAG1 = 1; //    
      DataInp = Temp;}
    if(FLAG7 == 1){FLAG7 = 0;}else{FLAG7 = 1;}//    
    Temp = DataOut;
    if(FLAG7 == 0){Temp = swap(Temp);}
    Temp = (Temp | 0x0f) & 0xfe;
    if(FLAG7 == 1){Temp = Temp ^ 0x03;}
    PORTE =  Temp;
    DDRE = 0;
    if(PORTA.0 == 0){FLAG1 = 1;}
  goto RESTORE_and_return;      
 PERIPHERAL_service:
#asm        
    dw  0xC000  ; goto 0
#endasm  
// goto RESTORE_and_return;
 T0CKI_service:             
 INT_service:
 RESTORE_and_return:
   interrupt_exit_and_restore
}
#pragma insertConst
const unsigned char DESCR[128] ={
0x12,	// DEVICE descriptor
0x01,0x00,0x10,0x0FF,0x00,0x0FF,0x08,0x34,
0x12,0x78,0x56,0x00,0x00,

0x01,	// indexes string desc
0x02,0x03,0x01,

0x09,	// CONFIGURATION descriptor
0x02,0x20,0x00,0x01,0x01,0x00,0x0C0,0x0A0,

0x09,	// INTERFACE descriptor
0x04,0x00,0x00,0x02,0x0FF,	// int class
0x01,	// interfeSubClass
0x0FF,	// int prot
0x00,

0x07,	// ENDPOINT 1 descriptor (out)
0x05,0x01,0x03,	// 02h
0x40,0x00,0x01,

0x07,	// ENDPOINT 2 descriptor (in)
0x05,0x82,0x03,	// 02h
0x40,0x00,0x01,

0x00,	// ENDPOINT 3 and 4 descriptor
0x00,0x00,0x00,0x00,0x00,0x00,

0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x08,	// Languages
0x03,0x09,0x04,0x09,0x04,0x09,0x04,

0x0A,	// String 1
0x03,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,

0x0A,	// String 2
0x03,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,

0x0A,	// String 3
0x03,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,	

0x0A,	// string 4
0x03,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,0x21,0x22,0x23,0x24,0x25,0x26,
	
0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31
};
//------------------------------------------------------------------------------
void PAUSE(unsigned char PS){
   unsigned char i;
   for (i=0;i<PS;i++);}
//------------------------------------------------------------------------------
void main(){
  unsigned char n;
  GLINTD = 1;    //   
  PORTE = 0x00;
  DDRE  = 0x00;  //  
  PORTC = 0x00;
  DDRC  = 0x00;  // 
  PORTD = 0x00;  
  DDRD  = 0x00;  // 
//     USB 
  for (n=0;n<128;n++){
    DESCR_ADR = n;
    DESCR_DATA = DESCR[n];}
//      ( 64)
  EP1_CFG1 = 0x40;   //     1
  EP2_CFG1 = 0x40;   //     2
//    
  EP1_CFG2 = 0x04;   // OUT Interrupt Transfer
  EP2_CFG2 = 0x02;   // IN  Interrupt Transfer
//  USB 
  USB_CTRL = 0x03;    //  "1"  1,   "1"  0
//           CONF_SET
  while ((!CONF_SET)){clrwdt();}
  USB_RST = 0;     //  RESET  USB_STAT,4 
//USB   -    USB  TMR0
  USB_IE1 = 0x00;     //   4    
  USB_IE2 = 0x80;     // USB_RST_IE = 1;
  USB_IE3 = 0x00;     //    USB  - 
  USB_IE4 = 0x08;     //    USB_OLL_IE
                      //  USB
  PIR1    = 0x00;     //   
  PIE1    = 0x04;     // USB_IE
  T0STA   = 0x20;     // TMR0 (.  ,  1:1)
  INTSTA  = 0x0a;     // PE_IE + TOIE

  DataInp = 0x00;	  //  ,   
  DataOut = 0x00;	  //   
  FLAG    = 0x00;	  //  
  GLINTD  = 0x00;     //    
  
  while (1){
    clrwdt();     
    if(EMPTY1 == 0){//    FIFO1
      DataOut = EP1_REG;}
    else{          //       .       
      if((FLAG1 == 1)&&(EMPTY2 == 1)){//    FIFO2
        EP2_REG = DataInp; //   
//DebugBreakPoint;  
        FLAG1 = 0;}}}
}
#include "Debug.c"
