
; CC7A Ver 1.0B, Copyright (c) B Knudsen Data
; C compiler for the PIC18 microcontrollers
; ************   1. Jun 2010  18:14  *************

        processor  VE5
        radix  DEC

PCLATH      EQU   0x03
ALUSTA      EQU   0x04
T0STA       EQU   0x05
INTSTA      EQU   0x07
WREG        EQU   0x0A
BSR         EQU   0x0F
DDRA        EQU   0x110
PORTA       EQU   0x111
DDRC        EQU   0x112
DDRD        EQU   0x114
PORTD       EQU   0x115
DDRE        EQU   0x116
PORTE       EQU   0x117
PR1         EQU   0x214
PW1DCL      EQU   0x310
PW1DCH      EQU   0x312
TCON1       EQU   0x316
TCON2       EQU   0x317
PIR1        EQU   0x510
T1IF        EQU   4
PIE1        EQU   0x511
ADCON0      EQU   0x614
GO_DONE     EQU   2
ADON        EQU   0
ADCON1      EQU   0x615
ADRESL      EQU   0x616
ADRESH      EQU   0x617
GLINTD      EQU   4
T0IF        EQU   5
PWMCnt      EQU   0x22
cmd         EQU   0x23
a           EQU   0x24
sBSR        EQU   0x1A
sALUSTA     EQU   0x1B
sWREG       EQU   0x20
sPCLATH     EQU   0x21

        GOTO main

  ; FILE D:\Soft\IDE1886\cc7ab\1886VE5.h
                        ;// Header file
                        ;#pragma chip VE5, core 16 b, code 16384, ram 26 : 0x3FF
                        ;#pragma limitedSkipUsage 1   // enable limited skip mode

  ; FILE D:\Soft\IDE1886\Examples\VE5_Test_CC7A\main.c
                        ;#include "1886VE5.h"
                        ;
                        ;unsigned char PWMCnt, cmd, a;
                        ;const int b = 0x10;
                        ;uns32 c;
                        ;/****************************************************/
                        ;#include "int17xxx.h"
                        ;#pragma origin 0x8
        ORG 0x0008
                        ;interrupt iServer(void)
                        ;{
iServer
                        ;    multi_interrupt_entry_and_save
        MOVFP BSR,sBSR
        MOVFP ALUSTA,sALUSTA
        CLRF  BSR,1
        MOVPF PCLATH,sPCLATH
        MOVWF sWREG
        CLRF  PCLATH,1
        GOTO  m002
        NOP  
        MOVFP BSR,sBSR
        MOVFP ALUSTA,sALUSTA
        CLRF  BSR,1
        MOVPF PCLATH,sPCLATH
        MOVWF sWREG
        CLRF  PCLATH,1
        GOTO  m001
        NOP  
        MOVFP BSR,sBSR
        MOVFP ALUSTA,sALUSTA
        CLRF  BSR,1
        MOVPF PCLATH,sPCLATH
        MOVWF sWREG
        CLRF  PCLATH,1
        GOTO  m002
        NOP  
        MOVFP BSR,sBSR
        MOVFP ALUSTA,sALUSTA
        CLRF  BSR,1
        MOVPF PCLATH,sPCLATH
        MOVWF sWREG
        CLRF  PCLATH,1
                        ;
                        ; PERIPHERAL_service:
                        ; TMR0_service:
                        ;    // save on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
                        ;    /* process Timer 0 interrupt */
                        ;    // T0IF is automatically cleared when the CPU vectors to 0x10
                        ;    // restore on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
                        ;     T1IF = 0;
m001    MOVLB 5
        BCF   0x510,T1IF
                        ;     PW1DCH = PW1DCH + 0x10;
        MOVLW 16
        MOVLB 3
        ADDWF PW1DCH,1
                        ;     if (PW1DCH == 0)
        TSTFSZ PW1DCH
        GOTO  m002
                        ;        if (--PWMCnt == 0)
        DECFSZ PWMCnt,1
        GOTO  m002
                        ;           TCON2 = 0; // stop
        CLRF  TCON2,1
                        ; T0CKI_service:
                        ; INT_service:
                        ;    interrupt_exit_and_restore
m002    MOVFP sWREG,WREG
        MOVFP sPCLATH,PCLATH
        MOVFP sALUSTA,ALUSTA
        MOVFP sBSR,BSR
        RETFIE
                        ;}
                        ;
                        ;//#include <math32.h>
                        ;/****************************************************/
                        ;void Beep()
                        ;{
Beep
                        ;     PW1DCH = 0;
        CLRF  PW1DCH,1
                        ;     PWMCnt = 0;
        CLRF  PWMCnt,1
                        ;     TCON2 = 0x11; // start interrupt
        MOVLW 17
        MOVWF TCON2
                        ;}
        RETURN
                        ;
                        ;/****************************************************/
                        ;void main()
                        ;{/*      :
                        ;; PA0 (.) INH_MK
                        ;; PA1 (.)      32..8
                        ;; PA2 (.)     USART
                        ;; PA3 ()     USART
                        ;; PA4  
                        ;; PA5 () NSLP_LIN
                        ;
                        ;; PC0 ( )  
                        ;; PC1   
                        ; 
                        ;; PC2-7 (.)  0-5
                        ;
                        ;; PD0,1 (.)  6,7
                        ;; PD2 (.)  1
                        ;; PD3 (.)  SW3
                        ;; PD4-7 (.) Led0-3
                        ;
                        ;; PE0-3 (.) Led4-7
                        ;*/
main
                        ;  GLINTD = 1;
        BSF   0x06,GLINTD
                        ;  PORTA = 0;
        MOVLB 1
        CLRF  PORTA,1
                        ;  DDRA = 0b000111;
        MOVLW 7
        MOVWF DDRA
                        ;  
                        ;  PORTD = 0;
        CLRF  PORTD,1
                        ;  DDRD = 0b00001011;
        MOVLW 11
        MOVWF DDRD
                        ;  PORTE = 0; // Led4-7 off 
        CLRF  PORTE,1
                        ;  DDRE = 0; // output
        CLRF  DDRE,1
                        ;  
                        ;  DDRC = 0b11111111; // all input (after reset)
        SETF  DDRC,1
                        ;  ADCON1 = 0b01101100; // set analog input, Fc/32
        MOVLW 108
        MOVLB 6
        MOVWF ADCON1
                        ;  ADCON0 = 0b00000000; // AD0
        CLRF  ADCON0,1
                        ;  ADON = 1; // ADC on
        BSF   0x614,ADON
                        ;  
                        ;  T0STA = 0b00100100; // Timer0 1:4, 15Hz for 16MHz
        MOVLW 36
        MOVWF T0STA
                        ;  cmd = 0;
        MOVLR 0
        CLRF  cmd,1
                        ;// init PWM
                        ;  PR1 = 0xFF; //Period
        MOVLB 2
        SETF  PR1,1
                        ;  PW1DCL = 0x00;
        MOVLB 3
        CLRF  PW1DCL,1
                        ;  PIR1 = 0x00;
        MOVLB 5
        CLRF  PIR1,1
                        ;  PIE1 = 0x10;
        MOVLW 16
        MOVWF PIE1
                        ;  INTSTA = 0x08;
        MOVLW 8
        MOVWF INTSTA
                        ;  TCON1 = 0x00;
        MOVLB 3
        CLRF  TCON1,1
                        ;  TCON2 = 0x00;
        CLRF  TCON2,1
                        ;  
                        ;//  TMR0H = 0xFF; // for LF resonator
                        ;  
                        ;  GLINTD = 0; // interrupt enable
        BCF   0x06,GLINTD
                        ;  Beep();
        CALL  Beep
                        ;  GO_DONE = 1; // Start adc
        MOVLB 6
        BSF   0x614,GO_DONE
                        ;  while(1){ // main loop
                        ;    if (T0IF) // Timer0 Interrupt Flag
m003    BTFSS 0x07,T0IF
        GOTO  m003
                        ;    {
                        ;      T0IF = 0; // clear Timer0 Interrupt flag
        BCF   0x07,T0IF
                        ;//      TMR0H = 0xFF; // for LF resonator
                        ;      cmd++;
        INCF  cmd,1
                        ;        PORTD = (cmd << 4);// & 0xF0;
        SWAPF cmd,W
        ANDLW 240
        MOVLB 1
        MOVWF PORTD
                        ;        PORTE = (cmd >> 4);// & 0x0F;
        SWAPF cmd,W
        ANDLW 15
        MOVWF PORTE
                        ;      if (!GO_DONE)
        MOVLB 6
        BTFSC 0x614,GO_DONE
        GOTO  m003
                        ;      {  
                        ;        //TXREG1 = ADRESH | ((PORTD & 0x08) << 4); // send Button and high bits of ADC
                        ;        //while (!TX1IF){}
                        ;        a = ADRESH;
        MOVPF ADRESH,a
                        ;        a = ADRESL;
        MOVPF ADRESL,a
                        ;        GO_DONE = 1; // Start ADC
        BSF   0x614,GO_DONE
                        ;      }
                        ;    }
                        ;  }
        GOTO  m003

        END


; *** KEY INFO ***

; 0x0008 P0   45 word(s)  0 % : iServer
; 0x0035 P0    5 word(s)  0 % : Beep
; 0x003A P0   55 word(s)  0 % : main

; RAM usage: 11 bytes (4 local), 891 bytes free
; Maximum call level: 1 (+1 for interrupt)
;  Codepage 0 has  106 word(s) :   1 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 106 code words (0 %)
